program qpa;
uses crt;
const order=12;
      CostMagP=4514;
      CostMagN=870;

type list=array[1..order*order] of word;
type quad=array[1..order+2,1..order+2] of word;
type quad_l=array[1..order,1..order] of byte;
const primi:list=(
          1,    3,    5,    7,   11,   13,   17,   19,   23,   29,   31,
         37,   41,   43,   47,   53,   59,   61,   67,   71,   73,   79,
         83,   89,   97,  101,  103,  107,  109,  113,  127,  131,  137,
        139,  149,  151,  157,  163,  167,  173,  179,  181,  191,  193,
        197,  199,  211,  223,  227,  229,  233,  239,  241,  251,  257,
        263,  269,  271,  277,  281,  283,  293,  307,  311,  313,  317,
        331,  337,  347,  349,  353,  359,  367,  373,  379,  383,  389,
        397,  401,  409,  419,  421,  431,  433,  439,  443,  449,  457,
        461,  463,  467,  479,  487,  491,  499,  503,  509,  521,  523,
        541,  547,  557,  563,  569,  571,  577,  587,  593,  599,  601,
        607,  613,  617,  619,  631,  641,  643,  647,  653,  659,  661,
        673,  677,  683,  691,  701,  709,  719,  727,  733,  739,  743,
        751,  757,  761,  769,  773,  787,  797,  809,  811,  821,  823,
        827);


var quad1,
    quad2:quad;
    f:file of quad_l;
    x1,y1,x2,y2:byte;
    quit:boolean;
    k:char;
    num:word;
    tipo:(Tnormal,Tprimi);
    dir,name:string;
    debug:boolean;
    Count:word;
    primi_:array[1..827] of byte;

procedure riemp;
var j:byte;
    i:word;
begin
  for i:=1 to 827 do
    for j:=1 to 144 do
      if primi[j]=i then primi_[i]:=j
end;

procedure conv(var q:quad; var qq:quad_l);
var i:byte;
    j:byte;
begin
  for i:=1 to 12 do
   for j:=1 to 12 do
     begin
       qq[i,j]:=primi_[q[i,j]];
     end;
end;

procedure SaveQuad(var q:quad; n:string);
var qq:quad_l;
begin
  assign(f,n);
  reset(f);
  conv(q,qq);
  seek(f,filesize(f));
  write(f,qq);
  close(f);
end;

procedure LoadQuad(var q:quad);
var qq:quad_l;
    i,j:byte;
begin
  read(f,qq);
  for i:=1 to 12 do
   for j:=1 to 12 do
     q[i,j]:=qq[i,j];
end;

procedure WriteQuad(var q:quad; c:word);
var i,j:byte;
begin
  for i:=1 to order do
   begin
    if q[i,Order+1]=c then TextBackground(15);
    for j:=1 to order do
      begin
        gotoxy(j*4+1,i);
        if odd(j) then TextColor(2)
                  else TextColor(3);
        write(q[i,j]:4);
      end;
    TextBackGround(0);
   end;
  for i:=1 to order do
    begin
      gotoxy((Order+1)*4+1,i);
      if q[i,Order+1]=c then TextColor(3)
                        else TextColor(5);
      write(q[i,Order+1]:8,' ',integer(c-q[i,Order+1]):6);
      gotoxy(i*4+1,Order+1);
      if q[Order+1,i]=c then TextColor(3)
                        else if odd(i) then TextColor(4)
                                       else TextColor(5);
      write(q[Order+1,i]:4);
      gotoxy(i*4+1,Order+2);
      write(integer(c-q[Order+1,i]):4);
    end;
  gotoxy((Order+1)*4+1,Order+1);
  if q[Order+1,Order+1]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+1,Order+1]:8);
  gotoxy((Order+1)*4+1,Order+2);
  write(integer(c-q[Order+1,Order+1]):5);
  gotoxy(1,Order+1);
  if q[Order+2,Order+2]=c then TextColor(3)
                          else TextColor(5);
  write(q[Order+2,Order+2]);
  gotoxy(1,Order+2);
  write(integer(c-q[Order+2,Order+2]):5);
end;

procedure SommaQuad(var q:quad);
var i,j:byte;
    s:word;
begin
  for i:=1 to order do
    begin
      s:=0;
      for j:=1 to order do
        s:=s+q[i,j];
      q[i,order+1]:=s;
    end;
  for j:=1 to order do
    begin
      s:=0;
      for i:=1 to order do
        s:=s+q[i,j];
      q[order+1,j]:=s;
    end;
  s:=0;
  for i:=1 to order do
    s:=s+q[i,i];
  q[order+1,order+1]:=s;
  s:=0;
  for i:=1 to order do
    s:=s+q[i,order+1-i];
  q[order+2,order+2]:=s;
end;

procedure RiempiQuad;
var i,j:byte;
begin
  for i:=1 to Order do
    for j:=1 to Order do
      quad2[i,j]:=primi[quad1[i,j]];
end;

procedure DeleteQuad(var q:quad);
var i,j:byte;
begin
  for i:=1 to Order+2 do
    for j:=1 to Order+2 do
      q[i,j]:=0;
end;

procedure RiempiRandom(var q:quad);
var i,i1,i2:byte;
begin
  for i:=1 to 144 do
    begin
      repeat
        i1:=random(12)+1;
        i2:=random(12)+1;
      until q[i1,i2]=0;
      q[i1,i2]:=i;
    end;
end;

procedure Swap(k:byte; var q:quad; i,j:byte);
var c:word;
begin
  c:=q[i,k];
  q[i,k]:=q[j,k];
  q[j,k]:=c;
end;

function Swapping(var q:quad;i,j:byte):boolean;
const hh=2;
var h:array[1..hh] of byte;
var a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15:byte;
begin
  swapping:=true;
  h[1]:=i;
  h[2]:=j;
  for a1:=1 to hh do
  for a2:=1 to hh do
  for a3:=1 to hh do
  for a4:=1 to hh do
  for a5:=1 to hh do
  for a6:=1 to hh do
  for a7:=1 to hh do
  for a8:=1 to hh do
  for a9:=1 to hh do
  for a10:=1 to hh do
  for a11:=1 to hh do
  for a12:=1 to hh do
    if q[h[a1],1]+
       q[h[a2],2]+
       q[h[a3],3]+
       q[h[a4],4]+
       q[h[a5],5]+
       q[h[a6],6]+
       q[h[a7],7]+
       q[h[a8],8]+
       q[h[a9],9]+
       q[h[a10],10]+
       q[h[a11],11]+
       q[h[a12],12]=CostMagP then
         begin
           if a1=2 then swap(1,q,i,j);
           if a2=2 then swap(2,q,i,j);
           if a3=2 then swap(3,q,i,j);
           if a4=2 then swap(4,q,i,j);
           if a5=2 then swap(5,q,i,j);
           if a6=2 then swap(6,q,i,j);
           if a7=2 then swap(7,q,i,j);
           if a8=2 then swap(8,q,i,j);
           if a9=2 then swap(9,q,i,j);
           if a10=2 then swap(10,q,i,j);
           if a11=2 then swap(11,q,i,j);
           if a12=2 then swap(12,q,i,j);
           exit;
         end;
   Swapping:=false;
end;

{scambia le righe in modo intelligente per trovare magicit
 si lavora con due righe alla volta, sperando che essendo riempito random
 non si abbiano problemi}
function IntellSwap(var q:quad):boolean;
var i:byte;
begin
  IntellSwap:=true;
  for i:=1 to Order-1 do
    begin
      if not(Swapping(q,i,i+1))
       then if i<Order-2 then if not Swapping(q,i,i+2) then begin
                                                              IntellSwap:=false;
                                                              exit
                                                            end
                                                       else
                         else begin
                                IntellSwap:=false;
                                exit
                              end
   end;
end;

procedure TrasfQuad(var q:quad);
var q1:quad;
    i,j:byte;
begin
  for i:=1 to order do
    for j:=1 to order do
      q1[j,i]:=q[i,j];
  q:=q1
end;

procedure Zmov;
var i:byte;
    h:word;
begin
  if y1=y2 then exit;
  for i:=1 to Order do
    begin
      h:=quad2[y1,i];
      quad2[y1,i]:=quad2[y2,i];
      quad2[y2,i]:=h;
    end;
    SommaQuad(quad2);
    k:=' ';
    if keypressed then k:=readkey;
    if upcase(k)='Y' then debug:=true;
    if upcase(k)='N' then debug:=false;
    if upcase(k)='Q' then halt;
    if debug then WriteQuad(quad2,CostMagP);
end;

function SistemaDiagonali:boolean;
var a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12:byte;
    hh:byte;
    q2:quad;
    c:char;
    s:string;
    esci:boolean;

procedure RRR(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12:byte);
begin
   y1:=1;  y2:=a1; Zmov;
    if a1=1 then a1:=a1;
    if a2=1 then a2:=a1;
    if a3=1 then a3:=a1;
    if a4=1 then a4:=a1;
    if a5=1 then a5:=a1;
    if a6=1 then a6:=a1;
    if a7=1 then a7:=a1;
    if a8=1 then a8:=a1;
    if a9=1 then a9:=a1;
    if a10=1 then a10:=a1;
    if a11=1 then a11:=a1;
    if a12=1 then a12:=a1;
   y1:=2;  y2:=a2; Zmov;
    if a1=2 then a1:=a2;
    if a2=2 then a2:=a2;
    if a3=2 then a3:=a2;
    if a4=2 then a4:=a2;
    if a5=2 then a5:=a2;
    if a6=2 then a6:=a2;
    if a7=2 then a7:=a2;
    if a8=2 then a8:=a2;
    if a9=2 then a9:=a2;
    if a10=2 then a10:=a2;
    if a11=2 then a11:=a2;
    if a12=2 then a12:=a2;
   y1:=3;  y2:=a3; Zmov;
    if a1=3 then a1:=a3;
    if a2=3 then a2:=a3;
    if a3=3 then a3:=a3;
    if a4=3 then a4:=a3;
    if a5=3 then a5:=a3;
    if a6=3 then a6:=a3;
    if a7=3 then a7:=a3;
    if a8=3 then a8:=a3;
    if a9=3 then a9:=a3;
    if a10=3 then a10:=a3;
    if a11=3 then a11:=a3;
    if a12=3 then a12:=a3;
   y1:=4;  y2:=a4; Zmov;
    if a1=4 then a1:=a4;
    if a2=4 then a2:=a4;
    if a3=4 then a3:=a4;
    if a4=4 then a4:=a4;
    if a5=4 then a5:=a4;
    if a6=4 then a6:=a4;
    if a7=4 then a7:=a4;
    if a8=4 then a8:=a4;
    if a9=4 then a9:=a4;
    if a10=4 then a10:=a4;
    if a11=4 then a11:=a4;
    if a12=4 then a12:=a4;
   y1:=5;  y2:=a5; Zmov;
    if a1=5 then a1:=a5;
    if a2=5 then a2:=a5;
    if a3=5 then a3:=a5;
    if a4=5 then a4:=a5;
    if a5=5 then a5:=a5;
    if a6=5 then a6:=a5;
    if a7=5 then a7:=a5;
    if a8=5 then a8:=a5;
    if a9=5 then a9:=a5;
    if a10=5 then a10:=a5;
    if a11=5 then a11:=a5;
    if a12=5 then a12:=a5;
   y1:=6;  y2:=a6; Zmov;
    if a1=6 then a1:=a6;
    if a2=6 then a2:=a6;
    if a3=6 then a3:=a6;
    if a4=6 then a4:=a6;
    if a5=6 then a5:=a6;
    if a6=6 then a6:=a6;
    if a7=6 then a7:=a6;
    if a8=6 then a8:=a6;
    if a9=6 then a9:=a6;
    if a10=6 then a10:=a6;
    if a11=6 then a11:=a6;
    if a12=6 then a12:=a6;
   y1:=7;  y2:=a7; Zmov;
    if a1=7 then a1:=a7;
    if a2=7 then a2:=a7;
    if a3=7 then a3:=a7;
    if a4=7 then a4:=a7;
    if a5=7 then a5:=a7;
    if a6=7 then a6:=a7;
    if a7=7 then a7:=a7;
    if a8=7 then a8:=a7;
    if a9=7 then a9:=a7;
    if a10=7 then a10:=a7;
    if a11=7 then a11:=a7;
    if a12=7 then a12:=a7;
   y1:=8;  y2:=a8; Zmov;
    if a1=8 then a1:=a8;
    if a2=8 then a2:=a8;
    if a3=8 then a3:=a8;
    if a4=8 then a4:=a8;
    if a5=8 then a5:=a8;
    if a6=8 then a6:=a8;
    if a7=8 then a7:=a8;
    if a8=8 then a8:=a8;
    if a9=8 then a9:=a8;
    if a10=8 then a10:=a8;
    if a11=8 then a11:=a8;
    if a12=8 then a12:=a8;
   y1:=9;  y2:=a9; Zmov;
    if a1=9 then a1:=a9;
    if a2=9 then a2:=a9;
    if a3=9 then a3:=a9;
    if a4=9 then a4:=a9;
    if a5=9 then a5:=a9;
    if a6=9 then a6:=a9;
    if a7=9 then a7:=a9;
    if a8=9 then a8:=a9;
    if a9=9 then a9:=a9;
    if a10=9 then a10:=a9;
    if a11=9 then a11:=a9;
    if a12=9 then a12:=a9;
   y1:=10; y2:=a10;Zmov;
    if a1=10 then a1:=a10;
    if a2=10 then a2:=a10;
    if a3=10 then a3:=a10;
    if a4=10 then a4:=a10;
    if a5=10 then a5:=a10;
    if a6=10 then a6:=a10;
    if a7=10 then a7:=a10;
    if a8=10 then a8:=a10;
    if a9=10 then a9:=a10;
    if a10=10 then a10:=a10;
    if a11=10 then a11:=a10;
    if a12=10 then a12:=a10;
   y1:=11; y2:=a11;Zmov;
    if a1=11 then a1:=a11;
    if a2=11 then a2:=a11;
    if a3=11 then a3:=a11;
    if a4=11 then a4:=a11;
    if a5=11 then a5:=a11;
    if a6=11 then a6:=a11;
    if a7=11 then a7:=a11;
    if a8=11 then a8:=a11;
    if a9=11 then a9:=a11;
    if a10=11 then a10:=a11;
    if a11=11 then a11:=a11;
    if a12=11 then a12:=a11;
   y1:=12; y2:=a12;Zmov;
end;


procedure Perm(var S:string;w:byte);
var n:byte;
begin
  if esci then exit;
  if w>=order then
           begin
                 if quad2[byte(s[1]),1]+
                    quad2[byte(s[2]),2]+
                    quad2[byte(s[3]),3]+
                    quad2[byte(s[4]),4]+
                    quad2[byte(s[5]),5]+
                    quad2[byte(s[6]),6]+
                    quad2[byte(s[7]),7]+
                    quad2[byte(s[8]),8]+
                    quad2[byte(s[9]),9]+
                    quad2[byte(s[10]),10]+
                    quad2[byte(s[11]),11]+
                    quad2[byte(s[12]),12]=CostMagP
                   then
                    begin
                      RRR(byte(s[1]),byte(s[2]),byte(s[3]),byte(s[4]),byte(s[5]),byte(s[6]),byte(s[7]),byte(s[8]),byte(s[9]),
                      byte(s[10]),byte(s[11]),byte(s[12]));
                      if quad2[order+2,order+2]=CostMagP
                         then begin
                                Count:=Count+1;
                                str(Count,name);
                                SaveQuad(quad2,'c:\tris\quad.yyy');
                                esci:=True;
                                exit;
                              end
                         else begin
                                gotoxy(1,23);
                                write(integer(CostMagP-quad2[order+2,order+2]));
                                quad2:=q2;
                                clreol;
                                {RiempiQuad;}
                              end;
                    end;
                 end
       else
       for n:=w to order do
       begin
         c:=s[n];
         s[n]:=s[w];
         s[w]:=c;
         perm(s,succ(w));
         c:=s[n];
         s[n]:=s[w];
         s[w]:=c;
       end;
end;

begin
  q2:=quad2;
  s:=#1+#2+#3+#4+#5+#6+#7+#8+#9+#10+#11+#12;
  esci:=false;
  perm(s,1);
  sistemadiagonali:=esci;
end;

procedure Swap2(k:byte; var q,q1:quad; i,j:byte);
var c:word;
begin
  c:=q[i,k];
  q[i,k]:=q[j,k];
  q[j,k]:=c;
  c:=q1[i,k];
  q1[i,k]:=q1[j,k];
  q1[j,k]:=c;
end;

function Swapping2(var q,q1:quad;i,j:byte):boolean;
const hh=2;
var h:array[1..hh] of byte;
var a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15:byte;
begin
  swapping2:=true;
  h[1]:=i;
  h[2]:=j;
  for a1:=1 to hh do
  for a2:=1 to hh do
  for a3:=1 to hh do
  for a4:=1 to hh do
  for a5:=1 to hh do
  for a6:=1 to hh do
  for a7:=1 to hh do
  for a8:=1 to hh do
  for a9:=1 to hh do
  for a10:=1 to hh do
  for a11:=1 to hh do
  for a12:=1 to hh do
    if q[h[a1],1]+
       q[h[a2],2]+
       q[h[a3],3]+
       q[h[a4],4]+
       q[h[a5],5]+
       q[h[a6],6]+
       q[h[a7],7]+
       q[h[a8],8]+
       q[h[a9],9]+
       q[h[a10],10]+
       q[h[a11],11]+
       q[h[a12],12]=CostMagN then
    if q1[h[a1],1]+
       q1[h[a2],2]+
       q1[h[a3],3]+
       q1[h[a4],4]+
       q1[h[a5],5]+
       q1[h[a6],6]+
       q1[h[a7],7]+
       q1[h[a8],8]+
       q1[h[a9],9]+
       q1[h[a10],10]+
       q1[h[a11],11]+
       q1[h[a12],12]=CostMagP then
         begin
           if a1=2 then swap2(1,q,q1,i,j);
           if a2=2 then swap2(2,q,q1,i,j);
           if a3=2 then swap2(3,q,q1,i,j);
           if a4=2 then swap2(4,q,q1,i,j);
           if a5=2 then swap2(5,q,q1,i,j);
           if a6=2 then swap2(6,q,q1,i,j);
           if a7=2 then swap2(7,q,q1,i,j);
           if a8=2 then swap2(8,q,q1,i,j);
           if a9=2 then swap2(9,q,q1,i,j);
           if a10=2 then swap2(10,q,q1,i,j);
           if a11=2 then swap2(11,q,q1,i,j);
           if a12=2 then swap2(12,q,q1,i,j);
           sommaquad(q);
           writequad(q,costmagn);
           exit;
         end;
   Swapping2:=false;
end;

function IntellSwap2(var q,q1:quad):boolean;
var i:byte;
begin
  IntellSwap2:=true;
  for i:=1 to Order-1 do
    begin
      if not(Swapping2(q,q1,i,i+1)) then
      if i<Order-2 then
       if not Swapping2(q,q1,i,i+2) then
        if i<order-3 then
          if not Swapping2(q,q1,i,i+3) then
          { if not Swapping2(q,q1,i,11) then
           if not Swapping2(q,q1,i,12) then}
                               begin
                                 IntellSwap2:=false;
{                                 exit}
                                end
                         else begin
                                IntellSwap2:=false;
{                                exit}
                              end
   end;
end;


label ripeti;

begin
  clrscr;
  assign(f,'c:\tris\quad.yyy');
  x1:=0;
  reset(f);
  repeat
   loadquad(quad1);
   SommaQuad(quad1);
  { writequad(quad1,costmagn);
   readln;}
   RiempiQuad;
   SommaQuad(quad2);
  { writequad(quad2,costmagp);
   readln;}
   if intellswap2(quad1,quad2) then writequad(quad1,costmagn);
   inc(x1);
   gotoxy(20,20);
   write(x1);
   readln;
  until false;
  close(f);

{  randomize;
  riemp;
  k:=' ';
  debug:=true;
  Count:=0;
  writeln('Per uscire premere Q o Crtl-Break');
  writeln('Premendo Y si vedranno le varie fasi stampate a video');
  writeln('Premendo N non le si vedranno (maggiore velocit in esecuzione)');
  clrscr;
  repeat
    ripeti:
    gotoxy(1,18);
    writeln('Trovati:',Count);
    gotoxy(1,19);
    clreol;
    gotoxy(1,20);
    clreol;
    gotoxy(1,21);
    clreol;

    DeleteQuad(quad1);
    DeleteQuad(quad2);
    RiempiRandom(quad1);
    SommaQuad(quad1);
    RiempiQuad;
    SommaQuad(quad2);
    if keypressed then k:=readkey;
    if upcase(k)='Y' then debug:=true;
    if upcase(k)='N' then debug:=false;
    if upcase(k)='Q' then halt;
    if debug then WriteQuad(quad2,CostMagP);
    gotoxy(1,19);
    writeln('Fase 1: ok');

    if not IntellSwap(Quad2) then
       if not IntellSwap(Quad2) then
         goto ripeti;
    SommaQuad(quad2);
    if keypressed then k:=readkey;
    if upcase(k)='Y' then debug:=true;
    if upcase(k)='N' then debug:=false;
    if upcase(k)='Q' then halt;
    if debug then WriteQuad(quad2,CostMagP);
    gotoxy(1,20);
    writeln('Fase 2: ok');

    TrasfQuad(quad2);
    SommaQuad(quad2);
    if not IntellSwap(Quad2) then
      if not IntellSwap(Quad2)
        then goto ripeti;
    SommaQuad(Quad2);
    if keypressed then k:=readkey;
    if upcase(k)='Y' then debug:=true;
    if upcase(k)='N' then debug:=false;
    if upcase(k)='Q' then halt;
    if debug then WriteQuad(quad2,CostMagP);
    gotoxy(1,21);
    writeln('Fase 3: ok');

    if not SistemaDiagonali then goto ripeti;
  until false;}


end.